/*
   Page 12 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.11: The Correct Put And Get Routines
*/
#define MAX 40  /*** author forgot this ***/
int buffer[MAX];
int count = 0;
int fill_ptr = 0;
int use_ptr = 0;

void put(int value) {
   buffer[fill_ptr] = value;
   fill_ptr = (fill_ptr + 1) % MAX;
   count++;
}

int get() {
   int tmp = buffer[use_ptr];
   use_ptr = (use_ptr + 1) % MAX;
   count--;
   return tmp;
}
