/*
   Page 2 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.2: Parent Waiting For Child: Spin-based Approach
*/
#include <stdio.h>
#include "mythreads.h"

volatile int done = 0;

void *child(void *arg)
{
   printf("child\n");
   done = 1;  // XXX indicate that we are done.
   return NULL;
}

int main( )
{
   printf("parent: begin\n");
   pthread_t c;
   Pthread_create(&c, NULL, child, NULL); // create child
   while (done == 0)/* empty */; // XXX spin to wait for child.
   printf("parent: end\n");
   return 0;
}
